<?php
namespace Claromentis\Infocapture\Repository;

$GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"] ?: array()) + array("project_i" . "d" => base64_decode("cHJvamVjd" . "F9pZA=="), "_49c6565477ee9f822b49" . "9a53e6d2995f" => base64_decode("YXJyYXlfa2V5X2V4" . "aXN0cw=="), "i" . "d" => base64_decode("aWQ" . "="), "_064a039fdabac69a532d3225" . "d0ed0f57" => base64_decode("UHJvamVjdC" . "Bub3QgZm91" . "bmQ="));
use Claromentis\Core\DAL;
use Claromentis\Infocapture\Exception\NotFoundException;
use Webmozart\Assert\Assert;
class ProjectRepository
{
    protected DAL\Db $database;
    
    
    
    
    
    
    protected array $projectCache = [];
    public function __construct(DAL\Db $_4504853ce5094b088c8bdc3d570a0a5d)
    {
        $this->database = $_4504853ce5094b088c8bdc3d570a0a5d;
    }
    
    
    
    
    
    
    
    public function findProject(int $projectId) : ?\HDProject
    {
        if (!$GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_49c6565477ee9f822b499a53e6" . "d2995f"]($projectId, $this->projectCache)) {
            $project = new \HDProject($this->database);
            if (!$project->Load($projectId)) {
                $project = null;
            }
            $this->projectCache[$projectId] = $project;
        }
        return $this->projectCache[$projectId];
    }
    
    
    
    
    
    
    
    
    public function findProjectOrFail(int $projectId) : \HDProject
    {
        $project = $this->findProject($projectId);
        if (null === $project) {
            throw new NotFoundException($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_064a039fdabac69a532d322" . "5d0ed0f57"]);
        }
        return $project;
    }
    
    
    
    
    
    
    
    
    
    
    
    
    public function findProjectsForIssues(array $issues) : array
    {
        Assert::allIsInstanceOf($issues, \HDIssue::class);
        $_68680c984182bf7876b2bb0ab77ebe01 = [];
        foreach ($issues as $issue) {
            $projectId = (int) $issue->GetProperty($GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["project_" . "id"]) ?? null;
            if ($projectId) {
                $issueId = $issue->GetProperty($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["i" . "d"]);
                $_68680c984182bf7876b2bb0ab77ebe01[$issueId] = $this->findProject($projectId);
            }
        }
        return $_68680c984182bf7876b2bb0ab77ebe01;
    }
    
    
    
    
    
    
    
    public function clearCache(?int $projectId = null) : void
    {
        if (isset($projectId)) {
            unset($this->projectCache[$projectId]);
        } else {
            $this->projectCache[$projectId] = null;
        }
    }
}